// buttonpress.sp

public ButtonPress(const String:name[], caller, activator, Float:delay)
{
	if(!IsValidEntity(caller) || !IsValidEntity(activator) || !g_bPluginEnabled)
		return;
	decl String:targetname[128];
	GetEdictClassname(activator,targetname, sizeof(targetname));
	if(!StrEqual(targetname,"player"))
		return;
	GetEntPropString(caller, Prop_Data, "m_iName", targetname, sizeof(targetname));
	if(StrEqual(targetname,"climb_startbutton"))
	{
		Call_StartForward(hStartPress);
		Call_PushCell(activator);
		Call_Finish();
	} 
	else if(StrEqual(targetname,"climb_endbutton")) 
	{
		Call_StartForward(hEndPress);
		Call_PushCell(activator);
		Call_Finish();
	}
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	hStartPress = CreateGlobalForward("CL_OnStartTimerPress", ET_Ignore, Param_Cell);
	hEndPress = CreateGlobalForward("CL_OnEndTimerPress", ET_Ignore, Param_Cell);
	return  APLRes_Success;
}

// - created Climb buttons -
public OnUsePost(entity, activator, caller, UseType:type, Float:value)
{
	if(!IsValidEntity(entity) || !IsValidEntity(activator) || !g_bPluginEnabled)
		return;
		
	
	decl String:targetname[128];
	GetEdictClassname(activator,targetname, sizeof(targetname));
	if(!StrEqual(targetname,"player"))
		return;
	GetEntPropString(entity, Prop_Data, "m_iName", targetname, sizeof(targetname));
	decl String:buffer[255];
	
	Format(buffer, sizeof(buffer), "play %s", RELATIVE_BUTTON_PATH); 
	if(StrEqual(targetname,"climb_startbutton"))
	{		
		ClientCommand(activator, buffer); 
		Call_StartForward(hStartPress);
		Call_PushCell(activator);
		Call_Finish();
	} 
	else if(StrEqual(targetname,"climb_endbutton")) 
	{
		ClientCommand(activator, buffer); 
		Call_StartForward(hEndPress);
		Call_PushCell(activator);
		Call_Finish();
	}
}  

// - Climb Button OnStartPress -
public CL_OnStartTimerPress(client)
{
	new Float:time;
	time = GetEngineTime() - g_fLastTimeNoClipUsed[client];
	if (g_bPluginEnabled == true && g_bSpectate[client] == false && g_bNoClip[client] == false && time > 2.0) 
	{
		//Get Cords&Angles for "!restart" command
		GetClientAbsOrigin(client, g_fPlayerCordsRestart[client]);
		GetClientEyeAngles(client, g_fPlayerAnglesRestart[client]);		

		//Get SteamID
		decl String:szSteamId[32];
		GetClientAuthString(client, szSteamId, 32);
	
		//set run variables
		g_CurrentCp[client] = -1;
		g_CounterCp[client] = 0;	
		g_OverallCp[client] = 0;
		g_OverallTp[client] = 0;
		g_fPauseTime[client] = 0.0;
		g_fStartPauseTime[client] = 0.0;
		g_bRestartCords[client] = true;
		g_bPause[client] = false;
		SetEntityMoveType(client, MOVETYPE_WALK);
		SetEntityRenderMode(client, RENDER_NORMAL);

		//DB
		db_setTmpDataRecord(client, szSteamId, g_szMapName);
		
		//Start time
		g_fStartTime[client] = GetEngineTime();

		
		//Center Msg
		decl String:szTpTime[32];
		decl String:szProTime[32];
		if (g_fPersonalRecord[client]<=0.0)
				Format(szTpTime, 32, "NONE");
		else
		{
			FormatTimeFloat(client, g_fPersonalRecord[client], 3);
			Format(szTpTime, 32, "%s", g_szTime[client]);
		}
		if (g_fPersonalRecordPro[client]<=0.0)
				Format(szProTime, 32, "NONE");
		else
		{
			FormatTimeFloat(client, g_fPersonalRecordPro[client], 3);
			Format(szProTime, 32, "%s", g_szTime[client]);
		}
		if (g_bTimeractivated[client] == true)
				PrintHintText(client,"Timer restarted\nPersonal best times:\n Pro: %s - TP: %s", szProTime,szTpTime);
		else
			PrintHintText(client,"Timer started\nYour Map Times:\n Pro: %s , TP: %s", szProTime,szTpTime);
			
		g_bMenuOpen[client] = false;		
		g_bTopMenuOpen[client]=false;	
		g_bTimeractivated[client] = true;	
	}
}

// - Climb Button OnEndPress -
public CL_OnEndTimerPress(client)
{
	if (g_bTimeractivated[client] == false || g_bPluginEnabled == false) return;
	
	g_bTimeractivated[client] = false;
	
	//decl
	decl String:szName[MAX_NAME_LENGTH];	
	decl String:szNameOpponent[MAX_NAME_LENGTH];	
	decl String:szSteamIdOpponent[32];
	decl String:szSteamId[32];
	decl String:szDifference[32]
	new teleports = g_OverallTp[client];
	new iRecordtype = 0;
	new bool:hasRecord;
	new Float: difference;
	//Get Name&SteamID
	GetClientAuthString(client, szSteamId, 32);
	GetClientName(client, szName, MAX_NAME_LENGTH);		
	
	//Final time
	g_fFinalTime[client] = GetEngineTime() - g_fStartTime[client] - g_fPauseTime[client];	
	
	//calc difference
	if (g_OverallTp[client]==0)
	{
		g_pr_multiplier[client]+=4;
		if (g_fPersonalRecordPro[client] > 0.0)
		{
			hasRecord=true;
			difference = g_fPersonalRecordPro[client] - g_fFinalTime[client];
			FormatTimeFloat(client, difference, 3);
		}
		else
			g_pr_finishedmaps_pro[client]++;
		
	}
	else
	{
		g_pr_multiplier[client]+=3;
		if (g_fPersonalRecord[client] > 0.0 && g_OverallTp[client] > 0)
		{
			hasRecord=true;
			difference = g_fPersonalRecord[client]-g_fFinalTime[client];
			FormatTimeFloat(client, difference, 3);
		}	
		else
			g_pr_finishedmaps_tp[client]++;			
	}
	if (hasRecord)
	{
		if (difference > 0.0)
			Format(szDifference, 32, "-%s", g_szTime[client]);
		else
			Format(szDifference, 32, "+%s", g_szTime[client]);
	}

	//Format Final Time
	FormatTimeFloat(client, g_fFinalTime[client], 3);
		

	//Map finished Msg
	for(new i = 1; i <= GetMaxClients(); i++) 
	{ 
		if(IsClientInGame(i) && !IsFakeClient(i)) 
		{ 
			if (!hasRecord)
			{
				PrintToChat(i, "%t", "MapFinished1",MOSSGREEN,WHITE,LIMEGREEN,szName,GRAY,LIMEGREEN, g_szTime[client],GRAY,LIMEGREEN,g_OverallTp[client],GRAY); 
				PrintToConsole(i, "%s finished with a time of (%s, TP's: %i).",szName,g_szTime[client],g_OverallTp[client]); 
			}
			else
			{
				if (difference> 0.0)
				{
					if (g_OverallTp[client]>0)
					{
						PrintToChat(i, "%t", "MapFinished2",MOSSGREEN,WHITE,LIMEGREEN,szName,GRAY,LIMEGREEN, g_szTime[client],GRAY,LIMEGREEN,g_OverallTp[client],GRAY,GREEN, szDifference,GRAY);  				
						PrintToConsole(i, "%s finished with a time of (%s, TP's: %i). Improving their best tp time by (%s)",szName,g_szTime[client],g_OverallTp[client],szDifference); 
					}
					else
					{
						PrintToChat(i, "%t", "MapFinished3",MOSSGREEN,WHITE,LIMEGREEN,szName,GRAY,LIMEGREEN, g_szTime[client],GRAY,LIMEGREEN,g_OverallTp[client],GRAY,GREEN, szDifference,GRAY);  				
						PrintToConsole(i, "%s finished with a time of (%s, TP's: %i). Improving their best pro time by (%s)",szName,g_szTime[client],g_OverallTp[client],szDifference); 					
					}
				}
				else
				{
					if (g_OverallTp[client]>0)
					{
						PrintToChat(i, "%t", "MapFinished4",MOSSGREEN,WHITE,LIMEGREEN,szName,GRAY,LIMEGREEN, g_szTime[client],GRAY,LIMEGREEN,g_OverallTp[client],GRAY,RED, szDifference,GRAY);  	
						PrintToConsole(i, "%s finished with a time of (%s, TP's: %i). Missing their best tp time by (%s)",szName,g_szTime[client],g_OverallTp[client],szDifference); 
					}
					else
					{
						PrintToChat(i, "%t", "MapFinished5",MOSSGREEN,WHITE,LIMEGREEN,szName,GRAY,LIMEGREEN, g_szTime[client],GRAY,LIMEGREEN,g_OverallTp[client],GRAY,RED, szDifference,GRAY);  	
						PrintToConsole(i, "%s finished with a time of (%s, TP's: %i). Missing their best pro time by (%s)",szName,g_szTime[client],g_OverallTp[client],szDifference); 
					}

				}
			}
		}
	}
	
	//NEW GLOBAL RECORD
	if (g_fFinalTime[client] < g_fRecordTimeGlobal && (!g_bMapButtons && g_BGlobalDBConnected && g_hDbGlobal != INVALID_HANDLE && g_bEnforcer && g_btickrate64) && !g_bBhopPluginEnabled) 
	{
		g_pr_multiplier[client]+= 2;
		for(new i = 1; i <= GetMaxClients(); i++) 
		{ 
			if(IsClientInGame(i) && !IsFakeClient(i)) 
			{ 
				PrintToChat(i, "%t", "NewGlobalRecord",MOSSGREEN,WHITE,LIMEGREEN,szName,GRAY,RED); 	
				PrintToConsole(i, "[KZ] %s scored a new GLOBAL RECORD",szName); 
			}
		}
		g_fRecordTimeGlobal = g_fFinalTime[client];
		Format(g_szRecordGlobalPlayer, MAX_NAME_LENGTH, "%s", szName);
		iRecordtype = 1;		
	}
	
	//NEW PRO RECORD
	if((g_fFinalTime[client] < g_fRecordTimePro) && g_OverallTp[client] <= 0)
	{
		g_pr_multiplier[client]+= 2;
		for(new i = 1; i <= GetMaxClients(); i++) 
		{ 
			if(IsClientInGame(i) && !IsFakeClient(i)) 
			{ 
				PrintToChat(i, "%t", "NewProRecord",MOSSGREEN,WHITE,LIMEGREEN,szName,GRAY,PURPLE);  
				PrintToConsole(i, "[KZ] %s scored a new PRO RECORD",szName); 
			}
		}
		g_fRecordTimePro = g_fFinalTime[client]; 
		Format(g_szRecordPlayerPro, MAX_NAME_LENGTH, "%s", szName);
		if (iRecordtype != 1)
			iRecordtype = 2;
	} 
	
	//NEW TP RECORD
	if((g_fFinalTime[client] < g_fRecordTime) && g_OverallTp[client] > 0)
	{
		g_pr_multiplier[client]++;
		for(new i = 1; i <= GetMaxClients(); i++) 
		{ 
			if(IsClientInGame(i) && !IsFakeClient(i)) 
			{ 
				PrintToChat(i, "%t", "NewTpRecord",MOSSGREEN,WHITE,LIMEGREEN,szName,GRAY,YELLOW); 	
				PrintToConsole(i, "[KZ] %s scored a new TP RECORD",szName); 
			}
		}
		g_fRecordTime = g_fFinalTime[client];
		Format(g_szRecordPlayer, MAX_NAME_LENGTH, "%s", szName);
		if (iRecordtype != 1)
			iRecordtype = 3;
	}
	
	//Challenge
	if (g_bChallenge[client])
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && i != client)
			{	
				GetClientAuthString(i, szSteamIdOpponent, 32);		
					if (StrEqual(szSteamIdOpponent,g_szCOpponentID[client]))
					{
						GetClientName(i, szNameOpponent, MAX_NAME_LENGTH);	
						g_bChallenge[i]=false;
						g_bChallenge[client]=false;
						PrintToChatAll("[%cKZ%c] %c%s%c won a challenge against %c%s%c!",RED,WHITE,MOSSGREEN,szName,WHITE,MOSSGREEN,szNameOpponent,WHITE); 	
						if (g_CBet[client]>0)
						{
							g_pr_multiplier[client]+= g_CBet[client];
							g_pr_multiplier[i] -= g_CBet[client];
							g_pr_showmsg[i] = true;
							new lostpoints = g_CBet[client] * g_pr_points_finished;
							for (new j = 1; j <= MaxClients; j++)
								if (1 <= j <= MaxClients && IsClientInGame(j) && IsValidEntity(j))
									PrintToChat(j, "[%cKZ%c] %c%s%c has lost %c%i %cpoints!", MOSSGREEN, WHITE, PURPLE,szNameOpponent, GRAY, RED, lostpoints,GRAY);
							CreateTimer(4.0, RefreshPoints, i);
						}
						g_pr_showmsg[i]=true;
						i = MaxClients;
					}
			}
		}		
	}
	
	//set mvp
	g_MVPStars[client] += 1;
	CS_SetMVPCount(client,g_MVPStars[client]);		
	
	//Record Sound
	PlayRecordSound(iRecordtype);		
	
	g_pr_showmsg[client] = true;
	//DB update
	if ((g_fFinalTime[client] < g_fPersonalRecord[client] || g_fPersonalRecord[client] <= 0.0 && teleports > 0) || (g_fFinalTime[client] < g_fPersonalRecordPro[client] || g_fPersonalRecordPro[client] <= 0.0 && teleports == 0))
	{
		g_pr_multiplier[client]++;
		db_selectRecord(client);
	}	
	
	//global db update
	if (!g_bMapButtons && g_BGlobalDBConnected && g_hDbGlobal != INVALID_HANDLE && g_bEnforcer && g_btickrate64 && !g_bBhopPluginEnabled)
		db_GlobalRecord(client);
	else
	{
		if (g_hDbGlobal == INVALID_HANDLE || !g_BGlobalDBConnected)
			PrintToConsole(client, "[KZ] Global Record disabled. Reason: No Connection to Web DB!");
		else
			if (g_bMapButtons)
				PrintToConsole(client, "[KZ] Global Record disabled. Reason: No implemented map buttons found!");
			else
				if (!g_bEnforcer)
					PrintToConsole(client, "[KZ] Global Record disabled. Reason: KZ Settings enforcer disabled!");
				else
					if (!g_btickrate64)
						PrintToConsole(client, "[KZ] Global Record disabled. Reason: Server tickrate > 64");
					else
						if (g_bBhopPluginEnabled)
							PrintToConsole(client, "[KZ] Global Record disabled. Reason: Bhop Plugin detected");
	}

	//reset&recordmenu
	g_CMOpen[client]=true;
	CreateTimer(2.0, DBUpdateTimer, client);
	g_bMenuOpen[client] = true;
	g_bTeleMenuOpen[client]=false;
	CreateTimer(0.15, OpenMapTimes, client);
	g_fStartTime[client] = -1.0;
	if (g_bMapFinished[client] == false && !StrEqual(g_pr_rankname[client],"MASTER"))
		PrintToChat(client, "%t", "NoClipUnlocked",MOSSGREEN,WHITE,YELLOW);
	g_bMapFinished[client] = true;
}